# Twilio Send SMS Module

## Summary

Online Marketing Automation Action to send a text message (SMS) via Twilio.

## Description 

This custom Automation Action steps leverages [Twilio](https://www.twilio.com/) to add another marketing channel to the Kentico platform.

Three pieces of info are needed from Twilio: Phone Number, Account SID, and Auth Token.  Account SID and Auth Token can be found in the console dashboard.  These will be used in Kentico settings.  
	
## Requirements

* Microsoft.IdentityModel.Logging
* Microsoft.IdentityModel.Tokens
* Newtonsoft.Json
* System.IdentityModel.Tokens.Jwt
* Twilio Rest API Helper Library
* Kentico 10
	

## Installation Web Site Project
	
1. Place TwilioSMSAutomationAction.cs in AppCode.
2. Comment out the following line above the namespace declaration in the TwilioSMSAutomationAction.cs file: 
```c#
	[assembly: RegisterCustomClass("TwilioSMS.TwilioSMSAutomationAction", typeof(TwilioSMS.TwilioSMSAutomationAction))]
```
3. Install Twilio Rest API via nuget package: Install-Package Twilio
4. Import TwilioSendSMSAutomation.zip into Kentico instance.
5. Twilio configuration will appear under Settings > Integrations > Twilio where you will set your: Twilio Account SID, Twilio Auth Token, and Twilio Phone Number
6. Under Marketing Automation > Automation Steps, edit the 'Send Twilio SMS' action. In the 'Action Configuration' section change the 'Action Provider' set Assembly Name to '(custom classes)' and change the Class name to 'TwilioSMS.TwilioSMSAutomationAction' and save.

## Installation Web Application Project

1. Update references to Kentico DLLs in project.
2. Pull packages from nuget.
3. Build TwilioSMS Project and place DLL into Kentico's /bin folder, along with DLLs from nuget.
4. Import TwilioSendSMSAutomation.zip into Kentico instance.
5. Twilio configuration will appear under Settings > Integrations > Twilio where you will set your: Twilio Account SID, Twilio Auth Token, and Twilio Phone Number

## Usage	

Once Twilio has been set up and configured via Settings, the new step Twilio Send SMS should be available in the Online Marketing Automation Workflow.  This has two parameters:

1. Recipient Number - The recipient number can be a static number or a macro to pull thie Contact's mobile number.  e.g. {% Contact.ContactMobilePhone %}
2. Message


## License

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
